/* $Id: cbase2.h,v 1.3 1997/01/11 03:11:03 masa-k Exp $
 *
 *  CBASE2: $BJ8;zHW(B $B!=(B $B?t;z!J@V!K(B
 */

/*
 *  Copyright (c) 1994 Masayuki Koba.
 *  Copyright (c) 1994 Motosoft (ORIGINAL).
 *
 *  $BK\%=%U%H%&%'%"$N%=!<%9$d%P%$%J%j$r:FG[I[$9$k>l9g$O!"<!$N>r7o$r=e<i$7$F(B
 *  $B2<$5$$!#(B
 *
 *  1. $BK\%=%U%H%&%'%"$rF~<j$7$?J}$K$O!"(BX11$BHG(B Emi Clock $B$N;HMQ8"$H!"Bh;0<T(B
 *     $B$X$N:FG[I[8"$,G'$a$i$l$^$9!#$?$@$7!":FG[I[$K4X$7$F$O!"F~<j;~$N%*%j(B
 *     $B%8%J%k$N$^$^2~JQ$;$:$K9T$&$3$H$,>r7o$G$9!#(B
 *  2. $BK\%=%U%H%&%'%"$N0lIt$^$?$OA4It$rCx:n8"<T$KL5CG$G2~JQ$7$FG[I[$9$k$3(B
 *     $B$H$O$G$-$^$;$s!#(B
 *  3. $BK\%=%U%H%&%'%"$N0lIt$^$?$OA4It$rCx:n8"<T$KL5CG$GFs<!MxMQ$9$k$3$H$O(B
 *     $B$G$-$^$;$s!#(B
 *  4. $BK\%=%U%H%&%'%"$r%7%9%F%`$K%P%s%I%k$7$?$j!"%7%9%F%`$NDI2C%Q%C%1!<%8(B
 *     $B$H$7$FBh;0<T$K:FG[I[$7$?$j$9$k>l9g$O!";vA0$KCx:n8"<T$K5v2D$,I,MW$G(B
 *     $B$9!#(B
 *  5. $BK\%=%U%H%&%'%"$r>&MQ$K;HMQ$9$k>l9g(B($B6bA,E*Mx1W$rF@$k>l9g(B)$B$O!";vA0$K(B
 *     $BCx:n8"<T$K5v2D$,I,MW$G$9!#$3$N>l9g!"4pK\E*$KM-=~$H$J$j$^$9!#(B
 *  6. $BK\%=%U%H%&%'%"$rMxMQ$9$k$3$H$K$h$C$FH/@8$7$?$$$+$J$kB;32$b!"Cx:n8"(B
 *     $B<T$OIi$o$J$$$b$N$H$7$^$9!#$3$l$K9g0U$G$-$J$$>l9g$O!";HMQ8"$,$J$$$b(B
 *     $B$N$H$7$^$9!#(B
 *  7. $B!H(BEmi Clock$B!I$N>&I8$*$h$SK\%=%U%H%&%'%"$N2hA|$d%G%6%$%s$K4X$9$kCx:n(B
 *     $B8"$O!"(BMotosoft $B$3$H!HK\(B $B=SLi!I;a$,M-$7$^$9!#(B
 *  8. $B!H(BEmi Clock$B!I$N>&I8$*$h$S2hA|$d%G%6%$%s$O!"(BX11$BHG(B Emi Clock $B3+H/$N$?(B
 *     $B$a!"(BMotosoft $B$h$j!H8E>l(B $B@59T!I$X8D?ME*$K%i%$%;%s%96!M?$5$l$F$^$9!#(B
 *     $BBh;0<T$XFs<!%i%$%;%s%96!M?$9$k$3$H$OG'$a$i$l$F$*$j$^$;$s!#(B
 *  9. Motosoft $B$H8E>l$KL5CG$G!"K\%=%U%H%&%'%"$N2hA|%G!<%?$rFs<!MxMQ$9$k$3(B
 *     $B$H$r6X;_$7$^$9!#(B
 * 10. $B$3$3$K5-=R$7$?0J30$N8"Mx$K$D$$$F$O!"F|K\9q$NCx:n8"K!$K$h$k$b$N$H$7(B
 *     $B$^$9!#(B
 */

static unsigned char	cbase2PaletteColors[27] = {
  /*  R     G     B  */
    0x00, 0x00, 0x01,	/* palette No. 0 */
    0xdc, 0x00, 0x00,	/* palette No. 1 */
    0xcc, 0x00, 0x00,	/* palette No. 2 */
    0xff, 0xff, 0xff,	/* palette No. 3 */
    0x65, 0x32, 0x32,	/* palette No. 4 */
    0xee, 0xee, 0xee,	/* palette No. 5 */
    0x00, 0x00, 0x66,	/* palette No. 6 */
    0x88, 0x00, 0x00,	/* palette No. 7 */
    0x98, 0x00, 0x00,	/* palette No. 8 */
};

static unsigned char	cbase2Pixels[2598] = {
    188, 0x00,  17, 0x01, 108, 0x00,  29, 0x01,  98, 0x00,  37, 0x01,
     91, 0x00,  43, 0x01,  85, 0x00,  49, 0x01,  80, 0x00,  53, 0x01,
     76, 0x00,  57, 0x01,  72, 0x00,  61, 0x01,  68, 0x00,  65, 0x01,
     65, 0x00,   6, 0x01,   1, 0x02,   1, 0x03,  59, 0x01,  62, 0x00,
      7, 0x01,   1, 0x03,  63, 0x01,  58, 0x00,   6, 0x01,   1, 0x02,
      2, 0x03,  66, 0x01,  55, 0x00,   6, 0x01,   3, 0x03,  25, 0x01,
      9, 0x04,  34, 0x01,  53, 0x00,   5, 0x01,   1, 0x02,   2, 0x03,
     20, 0x01,   6, 0x04,  11, 0x05,   6, 0x04,  28, 0x01,  51, 0x00,
      5, 0x01,   3, 0x03,  18, 0x01,   3, 0x04,  23, 0x05,   3, 0x04,
     26, 0x01,  48, 0x00,   6, 0x01,   3, 0x03,  16, 0x01,   2, 0x04,
     31, 0x05,   2, 0x04,  25, 0x01,  45, 0x00,   6, 0x01,   3, 0x03,
     14, 0x01,   2, 0x04,  37, 0x05,   2, 0x04,  23, 0x01,  43, 0x00,
      5, 0x01,   4, 0x03,  13, 0x01,   2, 0x04,  16, 0x05,   2, 0x06,
      3, 0x05,   4, 0x06,  16, 0x05,   2, 0x04,  22, 0x01,  41, 0x00,
      5, 0x01,   3, 0x03,  13, 0x01,   2, 0x04,  17, 0x05,   3, 0x06,
      2, 0x05,   2, 0x06,   2, 0x05,   2, 0x06,  17, 0x05,   3, 0x04,
     20, 0x01,  39, 0x00,   5, 0x01,   3, 0x03,  12, 0x01,   2, 0x04,
     20, 0x05,   2, 0x06,   6, 0x05,   2, 0x06,  19, 0x05,   2, 0x04,
     20, 0x01,  37, 0x00,   5, 0x01,   3, 0x03,  11, 0x01,   2, 0x04,
     22, 0x05,   2, 0x06,   6, 0x05,   2, 0x06,  21, 0x05,   2, 0x04,
     19, 0x01,  35, 0x00,   5, 0x01,   3, 0x03,  11, 0x01,   1, 0x04,
     24, 0x05,   2, 0x06,   5, 0x05,   2, 0x06,  24, 0x05,   2, 0x04,
     18, 0x01,  33, 0x00,   5, 0x01,   3, 0x03,  11, 0x01,   1, 0x04,
     25, 0x05,   2, 0x06,   4, 0x05,   2, 0x06,  26, 0x05,   1, 0x04,
     19, 0x01,  32, 0x00,   4, 0x01,   3, 0x03,  10, 0x01,   2, 0x04,
      6, 0x05,   2, 0x06,   4, 0x05,   2, 0x06,  12, 0x05,   2, 0x06,
      3, 0x05,   2, 0x06,  28, 0x05,   2, 0x04,  17, 0x01,  31, 0x00,
      4, 0x01,   3, 0x03,  10, 0x01,   1, 0x04,   7, 0x05,   3, 0x06,
      3, 0x05,   3, 0x06,  12, 0x05,   2, 0x06,   2, 0x05,   2, 0x06,
      2, 0x05,   2, 0x06,  16, 0x05,   2, 0x06,   9, 0x05,   1, 0x04,
     17, 0x01,  29, 0x00,   4, 0x01,   3, 0x03,  10, 0x01,   1, 0x04,
      9, 0x05,   2, 0x06,   4, 0x05,   2, 0x06,  11, 0x05,   4, 0x06,
      1, 0x05,   6, 0x06,  15, 0x05,   3, 0x06,  10, 0x05,   1, 0x04,
     17, 0x01,  27, 0x00,   5, 0x01,   2, 0x03,  10, 0x01,   1, 0x04,
     10, 0x05,   2, 0x06,   4, 0x05,   2, 0x06,  38, 0x05,   2, 0x06,
     11, 0x05,   1, 0x04,  17, 0x01,  25, 0x00,   5, 0x01,   2, 0x03,
     10, 0x01,   1, 0x04,  11, 0x05,   2, 0x06,   4, 0x05,   2, 0x06,
     38, 0x05,   2, 0x06,  12, 0x05,   2, 0x04,  16, 0x01,  24, 0x00,
      4, 0x01,   3, 0x03,   9, 0x01,   1, 0x04,  12, 0x05,   2, 0x06,
      4, 0x05,   2, 0x06,  38, 0x05,   2, 0x06,  13, 0x05,   1, 0x04,
     16, 0x01,  23, 0x00,   4, 0x01,   3, 0x03,   9, 0x01,   1, 0x04,
     13, 0x05,   2, 0x06,   4, 0x05,   2, 0x06,  38, 0x05,   2, 0x06,
     14, 0x05,   1, 0x04,  16, 0x01,  22, 0x00,   4, 0x01,   2, 0x03,
      9, 0x01,   1, 0x04,  14, 0x05,   2, 0x06,   4, 0x05,   2, 0x06,
     38, 0x05,   2, 0x06,  15, 0x05,   1, 0x04,  15, 0x01,  21, 0x00,
      4, 0x01,   2, 0x03,   9, 0x01,   1, 0x04,  14, 0x05,   4, 0x06,
      2, 0x05,   4, 0x06,  37, 0x05,   2, 0x06,  16, 0x05,   1, 0x04,
     15, 0x01,  19, 0x00,   4, 0x01,   2, 0x03,   9, 0x01,   1, 0x04,
     61, 0x05,   4, 0x06,  16, 0x05,   1, 0x04,  15, 0x01,  18, 0x00,
      4, 0x01,   1, 0x03,  10, 0x01,   1, 0x04,  81, 0x05,   1, 0x04,
     15, 0x01,  17, 0x00,   4, 0x01,   2, 0x03,   9, 0x01,   1, 0x04,
     83, 0x05,   1, 0x04,  15, 0x01,  16, 0x00,   4, 0x01,   1, 0x03,
      9, 0x01,   1, 0x04,  85, 0x05,   1, 0x04,  14, 0x01,  15, 0x00,
      4, 0x01,   1, 0x03,   9, 0x01,   1, 0x04,  87, 0x05,   1, 0x04,
     14, 0x01,  14, 0x00,  14, 0x01,   1, 0x04,  87, 0x05,   1, 0x04,
     14, 0x01,  13, 0x00,   4, 0x01,   1, 0x03,   9, 0x01,   1, 0x04,
     89, 0x05,   1, 0x04,  14, 0x01,  12, 0x00,  13, 0x01,   2, 0x04,
      5, 0x05,   2, 0x06,   4, 0x05,   3, 0x06,  75, 0x05,   1, 0x04,
     14, 0x01,  11, 0x00,  14, 0x01,   1, 0x04,   5, 0x05,   3, 0x06,
      3, 0x05,   2, 0x06,   1, 0x05,   2, 0x06,  65, 0x05,   4, 0x06,
      6, 0x05,   1, 0x04,  14, 0x01,  10, 0x00,  13, 0x01,   2, 0x04,
      6, 0x05,   2, 0x06,   2, 0x05,   2, 0x06,   3, 0x05,   2, 0x06,
     63, 0x05,   2, 0x06,   2, 0x05,   2, 0x06,   5, 0x05,   1, 0x04,
     14, 0x01,  10, 0x00,  13, 0x01,   1, 0x04,   7, 0x05,   2, 0x06,
      2, 0x05,   2, 0x06,   3, 0x05,   2, 0x06,  67, 0x05,   2, 0x06,
      6, 0x05,   1, 0x04,  13, 0x01,   9, 0x00,  14, 0x01,   1, 0x04,
      7, 0x05,   2, 0x06,   2, 0x05,   2, 0x06,   3, 0x05,   2, 0x06,
     67, 0x05,   2, 0x06,   6, 0x05,   1, 0x04,  14, 0x01,   8, 0x00,
     13, 0x01,   1, 0x04,   8, 0x05,   2, 0x06,   2, 0x05,   2, 0x06,
      3, 0x05,   2, 0x06,  66, 0x05,   2, 0x06,   8, 0x05,   1, 0x04,
     13, 0x01,   8, 0x00,  13, 0x01,   1, 0x04,   8, 0x05,   2, 0x06,
      2, 0x05,   2, 0x06,   3, 0x05,   2, 0x06,  65, 0x05,   2, 0x06,
      9, 0x05,   1, 0x04,  13, 0x01,   7, 0x00,  14, 0x01,   9, 0x05,
      2, 0x06,   3, 0x05,   2, 0x06,   1, 0x05,   2, 0x06,  65, 0x05,
      2, 0x06,  11, 0x05,   1, 0x04,  13, 0x01,   6, 0x00,  13, 0x01,
      1, 0x04,   8, 0x05,   4, 0x06,   3, 0x05,   3, 0x06,  65, 0x05,
      2, 0x06,   2, 0x05,   2, 0x06,   8, 0x05,   1, 0x04,  13, 0x01,
      6, 0x00,  13, 0x01,   1, 0x04,  83, 0x05,   6, 0x06,   8, 0x05,
      1, 0x04,  13, 0x01,   6, 0x00,  13, 0x01,  99, 0x05,  13, 0x01,
      5, 0x00,  13, 0x01,   1, 0x04,  99, 0x05,   1, 0x04,  13, 0x01,
      4, 0x00,  13, 0x01,   1, 0x04,  99, 0x05,   1, 0x04,  13, 0x01,
      4, 0x00,  13, 0x01,   1, 0x04,  99, 0x05,   1, 0x04,  13, 0x01,
      4, 0x00,  12, 0x01,   1, 0x04, 101, 0x05,   1, 0x04,  12, 0x01,
      4, 0x00,  12, 0x01,   1, 0x04, 101, 0x05,   1, 0x04,  12, 0x01,
      3, 0x00,  13, 0x01,   1, 0x04, 101, 0x05,   1, 0x04,  13, 0x01,
      2, 0x00,  13, 0x01,   1, 0x04, 101, 0x05,   1, 0x04,  13, 0x01,
      2, 0x00,  13, 0x01,   1, 0x04, 101, 0x05,   1, 0x04,  13, 0x01,
      2, 0x00,  13, 0x01,   1, 0x04, 101, 0x05,   1, 0x04,  13, 0x01,
      2, 0x00,  13, 0x01,   7, 0x05,   3, 0x06,  93, 0x05,  13, 0x01,
      2, 0x00,  12, 0x01,   1, 0x04,   6, 0x05,   2, 0x06,   1, 0x05,
      2, 0x06,  82, 0x05,   3, 0x06,   7, 0x05,   1, 0x04,  12, 0x01,
      2, 0x00,  12, 0x01,   1, 0x04,   5, 0x05,   2, 0x06,   3, 0x05,
      2, 0x06,  80, 0x05,   2, 0x06,   1, 0x05,   2, 0x06,   6, 0x05,
      1, 0x04,  12, 0x01,   2, 0x00,  12, 0x01,   1, 0x04,   5, 0x05,
      2, 0x06,   3, 0x05,   2, 0x06,  83, 0x05,   2, 0x06,   6, 0x05,
      1, 0x04,  12, 0x01,   2, 0x00,  12, 0x01,   1, 0x04,   5, 0x05,
      2, 0x06,   3, 0x05,   2, 0x06,  82, 0x05,   2, 0x06,   7, 0x05,
      1, 0x04,  12, 0x01,   2, 0x00,  12, 0x01,   1, 0x04,   6, 0x05,
      2, 0x06,   1, 0x05,   3, 0x06,  81, 0x05,   3, 0x06,   7, 0x05,
      1, 0x04,  12, 0x01,   2, 0x00,  12, 0x01,   1, 0x04,   7, 0x05,
      5, 0x06,  83, 0x05,   2, 0x06,   6, 0x05,   1, 0x04,  12, 0x01,
      2, 0x00,  12, 0x01,   1, 0x04,  10, 0x05,   2, 0x06,  84, 0x05,
      2, 0x06,   5, 0x05,   1, 0x04,   8, 0x01,   1, 0x07,   3, 0x01,
      2, 0x00,  12, 0x01,   1, 0x04,   9, 0x05,   2, 0x06,  85, 0x05,
      2, 0x06,   5, 0x05,   1, 0x04,  12, 0x01,   2, 0x00,  12, 0x01,
      1, 0x04,   7, 0x05,   3, 0x06,  86, 0x05,   2, 0x06,   5, 0x05,
      1, 0x04,   8, 0x01,   1, 0x07,   3, 0x01,   2, 0x00,  12, 0x01,
      1, 0x04,  91, 0x05,   2, 0x06,   2, 0x05,   2, 0x06,   6, 0x05,
      9, 0x01,   1, 0x07,   3, 0x01,   2, 0x00,  13, 0x01,   1, 0x04,
     91, 0x05,   4, 0x06,   6, 0x05,   1, 0x04,  13, 0x01,   2, 0x00,
     13, 0x01,   1, 0x04, 101, 0x05,   1, 0x04,   8, 0x01,   1, 0x07,
      4, 0x01,   2, 0x00,  13, 0x01,   1, 0x04, 101, 0x05,   1, 0x04,
      8, 0x01,   1, 0x07,   4, 0x01,   2, 0x00,  13, 0x01,   1, 0x04,
    101, 0x05,   1, 0x04,   8, 0x01,   1, 0x08,   4, 0x01,   3, 0x00,
     12, 0x01,   1, 0x04, 101, 0x05,   1, 0x04,   8, 0x01,   1, 0x07,
      3, 0x01,   4, 0x00,  12, 0x01,   1, 0x04, 101, 0x05,   1, 0x04,
      8, 0x01,   1, 0x07,   3, 0x01,   4, 0x00,  13, 0x01,   1, 0x04,
     99, 0x05,   1, 0x04,   8, 0x01,   1, 0x07,   1, 0x08,   3, 0x01,
      4, 0x00,  13, 0x01,   1, 0x04,  99, 0x05,   1, 0x04,   7, 0x01,
      1, 0x07,   1, 0x08,   4, 0x01,   4, 0x00,  13, 0x01,   1, 0x04,
     99, 0x05,   1, 0x04,   8, 0x01,   1, 0x08,   1, 0x07,   3, 0x01,
      5, 0x00,  12, 0x01,   1, 0x04,  99, 0x05,   8, 0x01,   1, 0x07,
      1, 0x08,   3, 0x01,   6, 0x00,  13, 0x01,   1, 0x04,  97, 0x05,
      1, 0x04,   8, 0x01,   1, 0x08,   1, 0x07,   3, 0x01,   6, 0x00,
     13, 0x01,   1, 0x04,  11, 0x05,   3, 0x06,  72, 0x05,   2, 0x06,
      9, 0x05,   1, 0x04,   7, 0x01,   1, 0x07,   1, 0x08,   4, 0x01,
      6, 0x00,  13, 0x01,   1, 0x04,  10, 0x05,   2, 0x06,   1, 0x05,
      2, 0x06,  70, 0x05,   2, 0x06,  10, 0x05,   8, 0x01,   1, 0x08,
      1, 0x07,   4, 0x01,   7, 0x00,  13, 0x01,   1, 0x04,   9, 0x05,
      2, 0x06,   1, 0x05,   2, 0x06,  69, 0x05,   2, 0x06,  10, 0x05,
      1, 0x04,   7, 0x01,   1, 0x07,   2, 0x08,   3, 0x01,   8, 0x00,
     13, 0x01,   1, 0x04,  10, 0x05,   3, 0x06,  69, 0x05,   2, 0x06,
      1, 0x05,   2, 0x06,   8, 0x05,   1, 0x04,   6, 0x01,   1, 0x07,
      2, 0x08,   1, 0x07,   3, 0x01,   8, 0x00,  14, 0x01,   1, 0x04,
      8, 0x05,   2, 0x06,   1, 0x05,   2, 0x06,  67, 0x05,   2, 0x06,
      2, 0x05,   2, 0x06,   7, 0x05,   1, 0x04,   7, 0x01,   3, 0x08,
      4, 0x01,   9, 0x00,  13, 0x01,   1, 0x04,   7, 0x05,   2, 0x06,
      3, 0x05,   2, 0x06,  66, 0x05,   7, 0x06,   6, 0x05,   1, 0x04,
      6, 0x01,   1, 0x07,   2, 0x08,   1, 0x07,   3, 0x01,  10, 0x00,
     13, 0x01,   2, 0x04,   6, 0x05,   2, 0x06,   3, 0x05,   2, 0x06,
     70, 0x05,   2, 0x06,   6, 0x05,   1, 0x04,   7, 0x01,   3, 0x08,
      4, 0x01,  10, 0x00,  14, 0x01,   1, 0x04,   6, 0x05,   2, 0x06,
      3, 0x05,   2, 0x06,  70, 0x05,   2, 0x06,   6, 0x05,   1, 0x04,
      6, 0x01,   1, 0x07,   2, 0x08,   1, 0x07,   4, 0x01,  11, 0x00,
     13, 0x01,   2, 0x04,   6, 0x05,   2, 0x06,   1, 0x05,   2, 0x06,
     70, 0x05,   4, 0x06,   4, 0x05,   1, 0x04,   7, 0x01,   2, 0x08,
      1, 0x07,   4, 0x01,  12, 0x00,  14, 0x01,   1, 0x04,   7, 0x05,
      3, 0x06,  79, 0x05,   1, 0x04,   6, 0x01,   1, 0x07,   2, 0x08,
      1, 0x07,   4, 0x01,  13, 0x00,  14, 0x01,   1, 0x04,  87, 0x05,
      1, 0x04,   7, 0x01,   1, 0x07,   2, 0x08,   4, 0x01,  14, 0x00,
     14, 0x01,   1, 0x04,  87, 0x05,   1, 0x04,   7, 0x01,   1, 0x08,
      1, 0x07,   1, 0x08,   4, 0x01,  15, 0x00,  14, 0x01,   1, 0x04,
     85, 0x05,   1, 0x04,   6, 0x01,   1, 0x07,   3, 0x08,   4, 0x01,
     16, 0x00,  14, 0x01,   2, 0x04,  83, 0x05,   1, 0x04,   7, 0x01,
      1, 0x07,   1, 0x08,   1, 0x07,   1, 0x08,   1, 0x07,   3, 0x01,
     17, 0x00,  14, 0x01,   2, 0x04,  81, 0x05,   2, 0x04,   7, 0x01,
      3, 0x08,   4, 0x01,  18, 0x00,  15, 0x01,   1, 0x04,  60, 0x05,
      6, 0x06,  15, 0x05,   1, 0x04,   6, 0x01,   1, 0x07,   1, 0x08,
      1, 0x07,   1, 0x08,   1, 0x07,   4, 0x01,  19, 0x00,  15, 0x01,
      1, 0x04,  59, 0x05,   2, 0x06,  18, 0x05,   1, 0x04,   7, 0x01,
      4, 0x08,   4, 0x01,  21, 0x00,  15, 0x01,   1, 0x04,  14, 0x05,
      7, 0x06,  37, 0x05,   2, 0x06,  17, 0x05,   1, 0x04,   6, 0x01,
      1, 0x07,   1, 0x08,   1, 0x07,   2, 0x08,   1, 0x07,   3, 0x01,
     22, 0x00,  15, 0x01,   2, 0x04,  13, 0x05,   2, 0x06,   3, 0x05,
      2, 0x06,  37, 0x05,   5, 0x06,  13, 0x05,   1, 0x04,   7, 0x01,
      3, 0x08,   1, 0x07,   1, 0x08,   4, 0x01,  23, 0x00,  15, 0x01,
      2, 0x04,  16, 0x05,   2, 0x06,  42, 0x05,   2, 0x06,  11, 0x05,
      2, 0x04,   6, 0x01,   1, 0x07,   2, 0x08,   1, 0x07,   1, 0x08,
      4, 0x01,  24, 0x00,  16, 0x01,   2, 0x04,  15, 0x05,   2, 0x06,
     43, 0x05,   2, 0x06,   9, 0x05,   2, 0x04,   6, 0x01,   1, 0x07,
      4, 0x08,   1, 0x07,   4, 0x01,  25, 0x00,  16, 0x01,   2, 0x04,
     13, 0x05,   2, 0x06,  18, 0x05,   3, 0x06,  23, 0x05,   2, 0x06,
      8, 0x05,   1, 0x04,   7, 0x01,   1, 0x07,   3, 0x08,   1, 0x07,
      5, 0x01,  27, 0x00,  16, 0x01,   2, 0x04,  12, 0x05,   2, 0x06,
     17, 0x05,   2, 0x06,  25, 0x05,   2, 0x06,   7, 0x05,   1, 0x04,
      8, 0x01,   1, 0x07,   3, 0x08,   1, 0x07,   4, 0x01,  29, 0x00,
     17, 0x01,   1, 0x04,  10, 0x05,   2, 0x06,  17, 0x05,   2, 0x06,
     25, 0x05,   2, 0x06,   7, 0x05,   1, 0x04,   8, 0x01,   1, 0x07,
      2, 0x08,   1, 0x07,   1, 0x08,   4, 0x01,  31, 0x00,  17, 0x01,
      2, 0x04,   8, 0x05,   2, 0x06,  17, 0x05,   5, 0x06,  21, 0x05,
      2, 0x06,   6, 0x05,   2, 0x04,   7, 0x01,   1, 0x07,   5, 0x08,
      4, 0x01,  32, 0x00,  18, 0x01,   2, 0x04,   7, 0x05,   2, 0x06,
     17, 0x05,   3, 0x06,   1, 0x05,   2, 0x06,  17, 0x05,   4, 0x06,
      6, 0x05,   1, 0x04,   9, 0x01,   1, 0x07,   2, 0x08,   1, 0x07,
      1, 0x08,   5, 0x01,  33, 0x00,  19, 0x01,   1, 0x04,  25, 0x05,
      2, 0x06,   3, 0x05,   2, 0x06,  25, 0x05,   1, 0x04,   8, 0x01,
      1, 0x07,   3, 0x08,   1, 0x07,   1, 0x08,   5, 0x01,  35, 0x00,
     19, 0x01,   2, 0x04,  23, 0x05,   2, 0x06,   3, 0x05,   2, 0x06,
     23, 0x05,   2, 0x04,   8, 0x01,   1, 0x07,   5, 0x08,   5, 0x01,
     37, 0x00,  20, 0x01,   2, 0x04,  21, 0x05,   2, 0x06,   3, 0x05,
      2, 0x06,  21, 0x05,   2, 0x04,  10, 0x01,   3, 0x08,   2, 0x07,
      5, 0x01,  39, 0x00,  20, 0x01,   3, 0x04,  20, 0x05,   2, 0x06,
      1, 0x05,   2, 0x06,  20, 0x05,   2, 0x04,  10, 0x01,   1, 0x07,
      1, 0x08,   1, 0x07,   3, 0x08,   5, 0x01,  41, 0x00,  21, 0x01,
      3, 0x04,  19, 0x05,   3, 0x06,  19, 0x05,   2, 0x04,  11, 0x01,
      1, 0x07,   3, 0x08,   1, 0x07,   1, 0x08,   5, 0x01,  43, 0x00,
     23, 0x01,   2, 0x04,  37, 0x05,   2, 0x04,  11, 0x01,   1, 0x07,
      4, 0x08,   1, 0x07,   6, 0x01,  45, 0x00,  25, 0x01,   2, 0x04,
     31, 0x05,   2, 0x04,  12, 0x01,   1, 0x07,   4, 0x08,   1, 0x07,
      1, 0x08,   6, 0x01,  48, 0x00,  26, 0x01,   3, 0x04,  23, 0x05,
      3, 0x04,  15, 0x01,   4, 0x08,   1, 0x07,   1, 0x08,   5, 0x01,
     51, 0x00,  28, 0x01,   6, 0x04,  11, 0x05,   6, 0x04,  16, 0x01,
      2, 0x08,   1, 0x07,   1, 0x08,   1, 0x07,   1, 0x08,   6, 0x01,
     53, 0x00,  34, 0x01,   9, 0x04,  21, 0x01,   1, 0x07,   4, 0x08,
      1, 0x07,   1, 0x08,   6, 0x01,  55, 0x00,  62, 0x01,   1, 0x07,
      3, 0x08,   1, 0x07,   1, 0x08,   7, 0x01,  58, 0x00,  58, 0x01,
      1, 0x07,   3, 0x08,   1, 0x07,   1, 0x08,   7, 0x01,  62, 0x00,
     53, 0x01,   2, 0x07,   2, 0x08,   1, 0x07,   2, 0x08,   7, 0x01,
     65, 0x00,  50, 0x01,   2, 0x07,   3, 0x08,   1, 0x07,   1, 0x08,
      1, 0x01,   1, 0x07,   6, 0x01,  68, 0x00,  46, 0x01,   1, 0x07,
      4, 0x08,   1, 0x07,   1, 0x08,   8, 0x01,  72, 0x00,  42, 0x01,
      1, 0x07,   2, 0x08,   1, 0x07,   1, 0x08,   1, 0x07,   9, 0x01,
     76, 0x00,  36, 0x01,   1, 0x07,   1, 0x01,   1, 0x07,   4, 0x08,
     10, 0x01,  80, 0x00,  30, 0x01,   1, 0x07,   1, 0x01,   1, 0x07,
      4, 0x08,  12, 0x01,  85, 0x00,  23, 0x01,   3, 0x07,   1, 0x08,
     16, 0x01,  91, 0x00,  37, 0x01,  98, 0x00,  29, 0x01, 108, 0x00,
     17, 0x01, 187, 0x00,   1, 0x03, 
};

static PixelImage	cbase2Image = {
    131, 131,			/* width, height */
    9,				/* numOfPalettes */
    cbase2PaletteColors,	/* paletteColor */
    cbase2Pixels,		/* pixel (compressed) */
};
