/* $Id: char16.h,v 1.3 1997/01/11 03:11:17 masa-k Exp $
 *
 *  CHAR16: $B%-%c%i%/%?(B $B!=(B $B%O%$%Q!<%P%H%k%9!<%D(B
 */

/*
 *  Copyright (c) 1994 Masayuki Koba.
 *  Copyright (c) 1994 Motosoft (ORIGINAL).
 *
 *  $BK\%=%U%H%&%'%"$N%=!<%9$d%P%$%J%j$r:FG[I[$9$k>l9g$O!"<!$N>r7o$r=e<i$7$F(B
 *  $B2<$5$$!#(B
 *
 *  1. $BK\%=%U%H%&%'%"$rF~<j$7$?J}$K$O!"(BX11$BHG(B Emi Clock $B$N;HMQ8"$H!"Bh;0<T(B
 *     $B$X$N:FG[I[8"$,G'$a$i$l$^$9!#$?$@$7!":FG[I[$K4X$7$F$O!"F~<j;~$N%*%j(B
 *     $B%8%J%k$N$^$^2~JQ$;$:$K9T$&$3$H$,>r7o$G$9!#(B
 *  2. $BK\%=%U%H%&%'%"$N0lIt$^$?$OA4It$rCx:n8"<T$KL5CG$G2~JQ$7$FG[I[$9$k$3(B
 *     $B$H$O$G$-$^$;$s!#(B
 *  3. $BK\%=%U%H%&%'%"$N0lIt$^$?$OA4It$rCx:n8"<T$KL5CG$GFs<!MxMQ$9$k$3$H$O(B
 *     $B$G$-$^$;$s!#(B
 *  4. $BK\%=%U%H%&%'%"$r%7%9%F%`$K%P%s%I%k$7$?$j!"%7%9%F%`$NDI2C%Q%C%1!<%8(B
 *     $B$H$7$FBh;0<T$K:FG[I[$7$?$j$9$k>l9g$O!";vA0$KCx:n8"<T$K5v2D$,I,MW$G(B
 *     $B$9!#(B
 *  5. $BK\%=%U%H%&%'%"$r>&MQ$K;HMQ$9$k>l9g(B($B6bA,E*Mx1W$rF@$k>l9g(B)$B$O!";vA0$K(B
 *     $BCx:n8"<T$K5v2D$,I,MW$G$9!#$3$N>l9g!"4pK\E*$KM-=~$H$J$j$^$9!#(B
 *  6. $BK\%=%U%H%&%'%"$rMxMQ$9$k$3$H$K$h$C$FH/@8$7$?$$$+$J$kB;32$b!"Cx:n8"(B
 *     $B<T$OIi$o$J$$$b$N$H$7$^$9!#$3$l$K9g0U$G$-$J$$>l9g$O!";HMQ8"$,$J$$$b(B
 *     $B$N$H$7$^$9!#(B
 *  7. $B!H(BEmi Clock$B!I$N>&I8$*$h$SK\%=%U%H%&%'%"$N2hA|$d%G%6%$%s$K4X$9$kCx:n(B
 *     $B8"$O!"(BMotosoft $B$3$H!HK\(B $B=SLi!I;a$,M-$7$^$9!#(B
 *  8. $B!H(BEmi Clock$B!I$N>&I8$*$h$S2hA|$d%G%6%$%s$O!"(BX11$BHG(B Emi Clock $B3+H/$N$?(B
 *     $B$a!"(BMotosoft $B$h$j!H8E>l(B $B@59T!I$X8D?ME*$K%i%$%;%s%96!M?$5$l$F$^$9!#(B
 *     $BBh;0<T$XFs<!%i%$%;%s%96!M?$9$k$3$H$OG'$a$i$l$F$*$j$^$;$s!#(B
 *  9. Motosoft $B$H8E>l$KL5CG$G!"K\%=%U%H%&%'%"$N2hA|%G!<%?$rFs<!MxMQ$9$k$3(B
 *     $B$H$r6X;_$7$^$9!#(B
 * 10. $B$3$3$K5-=R$7$?0J30$N8"Mx$K$D$$$F$O!"F|K\9q$NCx:n8"K!$K$h$k$b$N$H$7(B
 *     $B$^$9!#(B
 */

static unsigned char	char16PaletteColors[90] = {
  /*  R     G     B  */
    0xee, 0xee, 0xee,	/* palette No. 0 */
    0x00, 0x00, 0x01,	/* palette No. 1 */
    0x88, 0x88, 0x88,	/* palette No. 2 */
    0xbb, 0xbb, 0xbb,	/* palette No. 3 */
    0x22, 0x22, 0x22,	/* palette No. 4 */
    0xff, 0xff, 0xff,	/* palette No. 5 */
    0x55, 0x55, 0x55,	/* palette No. 6 */
    0x44, 0x44, 0x44,	/* palette No. 7 */
    0x33, 0x99, 0xff,	/* palette No. 8 */
    0x33, 0x66, 0xff,	/* palette No. 9 */
    0x33, 0xcc, 0xff,	/* palette No.10 */
    0xcb, 0xff, 0xff,	/* palette No.11 */
    0x33, 0x33, 0x33,	/* palette No.12 */
    0xff, 0x98, 0x65,	/* palette No.13 */
    0x77, 0x77, 0x77,	/* palette No.14 */
    0xff, 0xcb, 0x99,	/* palette No.15 */
    0xff, 0xcc, 0x33,	/* palette No.16 */
    0x32, 0x65, 0x32,	/* palette No.17 */
    0xfd, 0x98, 0x00,	/* palette No.18 */
    0x33, 0x99, 0x33,	/* palette No.19 */
    0x65, 0xcb, 0x32,	/* palette No.20 */
    0xff, 0x65, 0xfe,	/* palette No.21 */
    0xdc, 0x00, 0x00,	/* palette No.22 */
    0xdd, 0xdd, 0xdd,	/* palette No.23 */
    0xaa, 0xaa, 0xaa,	/* palette No.24 */
    0x98, 0x32, 0x00,	/* palette No.25 */
    0x76, 0x00, 0x00,	/* palette No.26 */
    0xff, 0xfe, 0x33,	/* palette No.27 */
    0x00, 0x32, 0x00,	/* palette No.28 */
    0xcc, 0x00, 0x00,	/* palette No.29 */
};

static unsigned char	char16Pixels[1950] = {
     54, 0x00,   9, 0x01,   5, 0x00,   1, 0x02,   1, 0x03,  22, 0x00,
      2, 0x01,   9, 0x04,   2, 0x01,   2, 0x00,   1, 0x02,   1, 0x05,
      1, 0x03,  20, 0x00,   2, 0x01,  12, 0x04,   1, 0x06,   1, 0x01,
      1, 0x02,   2, 0x05,   1, 0x03,  19, 0x00,   1, 0x01,   4, 0x06,
      4, 0x04,   1, 0x07,   3, 0x04,   1, 0x06,   1, 0x04,   1, 0x01,
      1, 0x02,   1, 0x08,   1, 0x05,   1, 0x03,  19, 0x00,   1, 0x01,
      1, 0x06,   1, 0x04,   1, 0x06,   1, 0x04,   1, 0x06,   1, 0x01,
      1, 0x06,   2, 0x04,   1, 0x07,   2, 0x06,   1, 0x01,   1, 0x04,
      1, 0x06,   1, 0x02,   2, 0x08,   1, 0x09,   1, 0x03,  18, 0x00,
      2, 0x01,   1, 0x06,   2, 0x07,   4, 0x06,   1, 0x04,   1, 0x06,
      1, 0x04,   1, 0x06,   1, 0x04,   3, 0x06,   3, 0x08,   1, 0x09,
      1, 0x06,   1, 0x01,  17, 0x00,   1, 0x01,   2, 0x06,   1, 0x04,
      1, 0x07,   1, 0x06,   1, 0x04,   5, 0x06,   1, 0x04,   1, 0x06,
      1, 0x04,   1, 0x06,   1, 0x02,   1, 0x08,   1, 0x0a,   1, 0x08,
      1, 0x09,   2, 0x01,  16, 0x00,   1, 0x01,   1, 0x04,   1, 0x06,
      2, 0x04,   1, 0x06,   1, 0x04,   1, 0x06,   2, 0x04,   1, 0x06,
      1, 0x01,   3, 0x06,   1, 0x04,   1, 0x06,   1, 0x09,   1, 0x0a,
      1, 0x0b,   1, 0x08,   1, 0x09,   1, 0x06,   2, 0x01,  15, 0x00,
      1, 0x01,   3, 0x04,   2, 0x01,   1, 0x07,   5, 0x01,   1, 0x04,
      1, 0x06,   1, 0x01,   1, 0x04,   1, 0x06,   1, 0x09,   1, 0x0a,
      1, 0x0b,   1, 0x08,   1, 0x09,   1, 0x04,   2, 0x01,  14, 0x00,
      2, 0x01,   1, 0x04,   4, 0x01,   2, 0x0c,   4, 0x01,   1, 0x04,
      2, 0x01,   1, 0x04,   1, 0x06,   1, 0x09,   1, 0x0a,   1, 0x0b,
      1, 0x08,   1, 0x09,   4, 0x01,  13, 0x00,   7, 0x01,   1, 0x0d,
      1, 0x0e,   2, 0x01,   1, 0x07,   6, 0x01,   2, 0x09,   1, 0x0a,
      2, 0x09,   4, 0x01,  13, 0x00,   4, 0x01,   2, 0x04,   1, 0x0e,
      1, 0x0d,   1, 0x0e,   1, 0x01,   1, 0x0c,   1, 0x07,   7, 0x01,
      3, 0x09,   5, 0x01,   1, 0x0e,  12, 0x00,   4, 0x01,   2, 0x04,
      2, 0x0d,   1, 0x0e,   1, 0x01,   1, 0x0e,   1, 0x0d,   1, 0x01,
      1, 0x0d,   1, 0x0c,   1, 0x04,   4, 0x01,   1, 0x09,   3, 0x01,
      1, 0x04,   1, 0x06,   1, 0x01,   1, 0x06,  12, 0x00,   2, 0x01,
      1, 0x04,   1, 0x01,   1, 0x04,   1, 0x0d,   2, 0x0f,   1, 0x0e,
      1, 0x01,   1, 0x0e,   1, 0x0d,   1, 0x01,   2, 0x0d,   1, 0x01,
      1, 0x04,   2, 0x01,   1, 0x04,   3, 0x01,   1, 0x06,   2, 0x04,
      1, 0x01,   1, 0x06,  12, 0x00,   1, 0x01,   3, 0x04,   1, 0x07,
      2, 0x0d,   1, 0x0f,   1, 0x0e,   1, 0x01,   1, 0x07,   1, 0x0d,
      1, 0x01,   2, 0x10,   1, 0x11,   2, 0x04,   2, 0x01,   1, 0x04,
      2, 0x01,   2, 0x04,   1, 0x06,   1, 0x01,   1, 0x06,  12, 0x00,
      1, 0x01,   1, 0x04,   1, 0x06,   1, 0x04,   1, 0x07,   1, 0x12,
      2, 0x10,   1, 0x0f,   1, 0x02,   1, 0x07,   2, 0x10,   2, 0x11,
      1, 0x13,   3, 0x04,   1, 0x01,   1, 0x06,   2, 0x01,   2, 0x04,
      1, 0x06,   1, 0x01,   1, 0x06,  12, 0x00,   1, 0x07,   1, 0x01,
      2, 0x04,   1, 0x07,   3, 0x11,   3, 0x10,   2, 0x11,   1, 0x07,
      3, 0x13,   1, 0x01,   1, 0x04,   1, 0x01,   1, 0x04,   2, 0x01,
      1, 0x06,   2, 0x04,   1, 0x01,   1, 0x06,  12, 0x00,   1, 0x07,
      2, 0x01,   1, 0x04,   1, 0x07,   1, 0x13,   1, 0x07,   3, 0x11,
      1, 0x12,   3, 0x13,   1, 0x07,   2, 0x13,   3, 0x04,   1, 0x06,
      2, 0x01,   2, 0x04,   1, 0x06,   1, 0x01,   1, 0x0e,  12, 0x00,
      1, 0x02,   2, 0x01,   1, 0x04,   1, 0x07,   2, 0x13,   1, 0x07,
      2, 0x11,   1, 0x14,   3, 0x13,   1, 0x07,   2, 0x13,   1, 0x0c,
      3, 0x04,   1, 0x01,   1, 0x04,   1, 0x06,   1, 0x01,   1, 0x04,
      1, 0x01,   1, 0x0e,  12, 0x00,   1, 0x02,   1, 0x07,   1, 0x01,
      1, 0x0c,   1, 0x07,   2, 0x13,   1, 0x07,   2, 0x11,   1, 0x14,
      4, 0x13,   3, 0x07,   3, 0x04,   1, 0x01,   1, 0x04,   2, 0x01,
      1, 0x07,   1, 0x01,   1, 0x0e,  12, 0x00,   1, 0x02,   1, 0x07,
      1, 0x01,   3, 0x07,   2, 0x13,   2, 0x11,   1, 0x14,   1, 0x13,
      3, 0x07,   2, 0x0f,   1, 0x0d,   1, 0x0e,   1, 0x04,   1, 0x07,
      1, 0x01,   1, 0x07,   2, 0x01,   1, 0x07,   1, 0x01,  13, 0x00,
      1, 0x02,   1, 0x07,   1, 0x01,   1, 0x0c,   1, 0x07,   1, 0x0d,
      6, 0x07,   1, 0x0f,   2, 0x0d,   1, 0x0f,   2, 0x0d,   1, 0x0c,
      1, 0x04,   1, 0x07,   1, 0x04,   1, 0x07,   1, 0x01,   1, 0x03,
      1, 0x0e,   1, 0x01,  13, 0x00,   2, 0x02,   2, 0x01,   1, 0x0c,
      2, 0x0d,   8, 0x0f,   2, 0x0d,   1, 0x06,   1, 0x0c,   2, 0x0e,
      2, 0x01,   1, 0x03,   1, 0x0f,   1, 0x0d,   1, 0x02,  13, 0x00,
      2, 0x02,   2, 0x01,   1, 0x0c,   1, 0x0e,   2, 0x0d,   2, 0x0f,
      1, 0x01,   1, 0x15,   1, 0x0f,   3, 0x0d,   1, 0x0e,   1, 0x01,
      1, 0x0d,   1, 0x0c,   2, 0x03,   1, 0x0e,   1, 0x03,   1, 0x0f,
      1, 0x0d,   1, 0x01,  15, 0x00,   1, 0x0e,   1, 0x03,   2, 0x02,
      2, 0x0e,   2, 0x0d,   2, 0x0f,   2, 0x0d,   1, 0x0e,   1, 0x06,
      1, 0x0e,   2, 0x0f,   1, 0x16,   1, 0x01,   2, 0x0e,   1, 0x0f,
      1, 0x03,   1, 0x0d,   1, 0x0e,  13, 0x00,   2, 0x03,   2, 0x17,
      3, 0x00,   1, 0x18,   1, 0x0c,   1, 0x0e,   1, 0x0c,   1, 0x0e,
      4, 0x0d,   1, 0x0f,   4, 0x16,   1, 0x0e,   1, 0x0f,   1, 0x0e,
      2, 0x0d,   1, 0x01,  13, 0x00,   1, 0x01,   1, 0x0e,   1, 0x0d,
      2, 0x0e,   1, 0x16,   1, 0x0e,   1, 0x02,   1, 0x0e,   2, 0x0f,
      3, 0x0d,   2, 0x0f,   4, 0x16,   1, 0x19,   1, 0x1a,   1, 0x0e,
      1, 0x03,   1, 0x0d,   1, 0x0e,   1, 0x03,  12, 0x00,   1, 0x0e,
      1, 0x0d,   1, 0x0e,   1, 0x0d,   1, 0x0f,   1, 0x0c,   5, 0x16,
      5, 0x0f,   4, 0x16,   2, 0x19,   1, 0x1a,   1, 0x0d,   3, 0x0f,
      1, 0x0d,   1, 0x0e,  11, 0x00,   1, 0x0e,   1, 0x0d,   2, 0x03,
      1, 0x0d,   1, 0x0f,   1, 0x0d,   1, 0x03,   1, 0x19,   4, 0x16,
      2, 0x0f,   3, 0x16,   5, 0x1a,   1, 0x0d,   3, 0x0f,   1, 0x0d,
      1, 0x01,   1, 0x0e,  11, 0x00,   1, 0x0c,   1, 0x0f,   1, 0x0e,
      3, 0x0f,   1, 0x0d,   2, 0x19,   5, 0x16,   1, 0x1b,   1, 0x1a,
      1, 0x0f,   1, 0x0d,   2, 0x0f,   1, 0x0d,   1, 0x0f,   1, 0x0e,
      3, 0x0d,   2, 0x1b,   1, 0x05,   1, 0x0c,   9, 0x00,   1, 0x03,
      1, 0x01,   4, 0x0f,   2, 0x0e,   1, 0x1a,   1, 0x16,   4, 0x1a,
      2, 0x1b,   1, 0x1a,   1, 0x0d,   1, 0x0f,   3, 0x0d,   1, 0x0f,
      1, 0x0d,   3, 0x1b,   2, 0x03,   1, 0x17,   1, 0x03,   1, 0x01,
      8, 0x00,   1, 0x0e,   1, 0x0d,   1, 0x03,   2, 0x0f,   3, 0x0d,
      2, 0x1a,   2, 0x0d,   1, 0x0f,   1, 0x0d,   2, 0x16,   1, 0x0f,
      2, 0x0d,   3, 0x00,   2, 0x0d,   3, 0x03,   2, 0x17,   1, 0x09,
      1, 0x03,   1, 0x01,   8, 0x00,   1, 0x0c,   1, 0x0e,   3, 0x0d,
      1, 0x1b,   2, 0x0e,   1, 0x0f,   1, 0x0d,   2, 0x00,   2, 0x0d,
      1, 0x1a,   1, 0x16,   1, 0x0d,   6, 0x00,   3, 0x03,   3, 0x17,
      1, 0x09,   1, 0x03,   1, 0x01,   8, 0x00,   1, 0x0e,   4, 0x1b,
      1, 0x03,   3, 0x0d,   5, 0x00,   1, 0x1a,   2, 0x16,   2, 0x00,
      1, 0x17,   4, 0x00,   1, 0x0e,   3, 0x03,   1, 0x09,   2, 0x03,
      1, 0x01,   8, 0x00,   1, 0x1c,   4, 0x03,   1, 0x17,   1, 0x03,
      1, 0x0e,   1, 0x03,   5, 0x00,   1, 0x1a,   1, 0x19,   1, 0x16,
      1, 0x00,   3, 0x17,   1, 0x1b,   1, 0x17,   1, 0x00,   1, 0x01,
      5, 0x03,   1, 0x01,   9, 0x00,   1, 0x1c,   1, 0x03,   1, 0x09,
      3, 0x17,   1, 0x03,   1, 0x0d,   1, 0x17,   1, 0x1b,   2, 0x00,
      2, 0x17,   1, 0x1a,   1, 0x19,   1, 0x16,   3, 0x17,   1, 0x1b,
      1, 0x12,   1, 0x03,   1, 0x16,   1, 0x1a,   2, 0x01,   1, 0x03,
      2, 0x01,  10, 0x00,   1, 0x1c,   1, 0x03,   1, 0x09,   3, 0x17,
      1, 0x03,   1, 0x07,   1, 0x03,   1, 0x12,   1, 0x1b,   3, 0x17,
      1, 0x1a,   1, 0x19,   1, 0x16,   3, 0x03,   1, 0x12,   1, 0x03,
      1, 0x02,   1, 0x16,   3, 0x1a,   1, 0x01,   2, 0x1a,  10, 0x00,
      1, 0x1c,   2, 0x03,   1, 0x09,   4, 0x03,   1, 0x01,   1, 0x03,
      1, 0x12,   3, 0x03,   1, 0x02,   1, 0x1a,   1, 0x16,   2, 0x02,
      2, 0x03,   1, 0x02,   1, 0x0f,   1, 0x16,   7, 0x1a,  10, 0x00,
      1, 0x01,   5, 0x03,   2, 0x01,   1, 0x16,   3, 0x03,   1, 0x02,
      2, 0x0f,   1, 0x1a,   2, 0x0f,   2, 0x02,   1, 0x0f,   1, 0x0d,
      1, 0x16,   4, 0x1a,   1, 0x16,   1, 0x19,   1, 0x1a,  11, 0x00,
      5, 0x01,   4, 0x1a,   2, 0x02,  10, 0x0f,   1, 0x0d,   1, 0x16,
      2, 0x1a,   3, 0x19,   1, 0x16,   1, 0x1a,  14, 0x00,   1, 0x1a,
      2, 0x16,   2, 0x1a,   1, 0x0d,  12, 0x0f,   1, 0x16,   2, 0x1a,
      1, 0x19,   1, 0x16,   1, 0x19,   1, 0x16,   1, 0x1a,  14, 0x00,
      1, 0x16,   1, 0x19,   2, 0x16,   1, 0x1a,   2, 0x0d,   4, 0x0f,
      1, 0x0d,   5, 0x0f,   1, 0x0d,   1, 0x16,   2, 0x1a,   1, 0x19,
      2, 0x16,   1, 0x19,   1, 0x1a,  13, 0x00,   1, 0x1a,   2, 0x16,
      2, 0x19,   2, 0x1a,   2, 0x0d,  10, 0x0f,   1, 0x16,   2, 0x1a,
      2, 0x19,   3, 0x16,   1, 0x1a,  12, 0x00,   1, 0x1a,   4, 0x16,
      2, 0x1a,   1, 0x16,   2, 0x0d,   8, 0x0f,   2, 0x16,   3, 0x1a,
      1, 0x19,   3, 0x16,   1, 0x1a,  12, 0x00,   1, 0x1a,   3, 0x16,
      1, 0x19,   3, 0x1a,   2, 0x16,   7, 0x0d,   2, 0x16,   4, 0x1a,
      4, 0x16,   1, 0x1a,  11, 0x00,   1, 0x1a,   4, 0x16,   2, 0x1d,
      1, 0x1a,   1, 0x0d,   2, 0x1a,   1, 0x16,   1, 0x1a,   1, 0x03,
      1, 0x00,   4, 0x16,   1, 0x1a,   2, 0x0d,   2, 0x1a,   5, 0x16,
      1, 0x1a,  10, 0x00,   1, 0x1a,   4, 0x16,   1, 0x1d,   2, 0x1a,
      1, 0x0f,   1, 0x0d,   3, 0x1a,   1, 0x03,   2, 0x00,   1, 0x1a,
      1, 0x16,   1, 0x1a,   2, 0x0d,   1, 0x0f,   3, 0x1a,   4, 0x16,
      1, 0x1a,  10, 0x00,   1, 0x1a,   4, 0x16,   1, 0x1d,   2, 0x1a,
      2, 0x0f,   1, 0x0d,   1, 0x1a,   2, 0x03,   3, 0x00,   1, 0x1a,
      1, 0x0d,   2, 0x0f,   1, 0x0d,   3, 0x1a,   4, 0x16,   1, 0x1a,
     10, 0x00,   1, 0x1a,   4, 0x16,   2, 0x1d,   1, 0x1a,   3, 0x0f,
      1, 0x1a,   2, 0x03,   3, 0x00,   1, 0x1a,   2, 0x0f,   1, 0x0d,
      1, 0x0f,   1, 0x0d,   2, 0x1a,   2, 0x19,   2, 0x16,   2, 0x1a,
      8, 0x00,   1, 0x1a,   5, 0x16,   1, 0x1d,   2, 0x1a,   4, 0x0f,
      1, 0x0e,   2, 0x03,   1, 0x00,   1, 0x0e,   4, 0x0f,   2, 0x0d,
      2, 0x1a,   1, 0x16,   1, 0x19,   2, 0x16,   2, 0x1a,   8, 0x00,
      1, 0x1a,   4, 0x16,   2, 0x1d,   2, 0x1a,   4, 0x0f,   1, 0x0d,
      1, 0x0e,   1, 0x03,   1, 0x0e,   1, 0x0d,   4, 0x0f,   2, 0x0d,
      3, 0x1a,   2, 0x19,   1, 0x16,   2, 0x1a,   8, 0x00,   1, 0x1a,
      3, 0x16,   2, 0x1d,   1, 0x19,   2, 0x1a,   5, 0x0f,   1, 0x0d,
      1, 0x06,   1, 0x0d,   5, 0x0f,   1, 0x0d,   1, 0x00,   3, 0x1a,
      1, 0x16,   1, 0x19,   1, 0x1a,   1, 0x16,   1, 0x1a,   8, 0x00,
      1, 0x1a,   3, 0x16,   1, 0x1d,   1, 0x19,   3, 0x1a,   4, 0x0f,
      2, 0x0d,   1, 0x0e,   6, 0x0f,   1, 0x0d,   1, 0x00,   5, 0x1a,
      1, 0x16,   1, 0x1a,   9, 0x00,   1, 0x1a,   3, 0x16,   2, 0x19,
      3, 0x1a,   5, 0x0f,   1, 0x0d,   1, 0x0e,   5, 0x0f,   2, 0x05,
      1, 0x03,   4, 0x1a,   1, 0x16,   2, 0x1a,  10, 0x00,   1, 0x1a,
      1, 0x16,   2, 0x19,   3, 0x1a,   1, 0x03,   5, 0x05,   1, 0x03,
      1, 0x0e,   5, 0x05,   1, 0x00,   1, 0x03,   1, 0x16,   5, 0x1a,
      1, 0x16,  11, 0x00,   1, 0x1a,   1, 0x16,   1, 0x19,   3, 0x1a,
      1, 0x00,   1, 0x0e,   5, 0x00,   1, 0x03,   1, 0x0e,   5, 0x00,
      3, 0x16,   1, 0x1a,   1, 0x00,   3, 0x1a,  13, 0x00,   1, 0x1a,
      1, 0x16,   2, 0x1a,   2, 0x00,   1, 0x1a,   6, 0x16,   1, 0x0e,
      7, 0x16,   2, 0x1a,   2, 0x00,   1, 0x1a,  15, 0x00,   2, 0x1a,
      3, 0x00,   1, 0x1a,   5, 0x16,   1, 0x1a,   1, 0x0e,   7, 0x16,
      2, 0x1a,  23, 0x00,   1, 0x1a,   4, 0x16,   2, 0x1a,   1, 0x0e,
      7, 0x16,   2, 0x1a,  48, 0x00, 
};

static PixelImage	char16Image = {
    40, 61,			/* width, height */
    30,				/* numOfPalettes */
    char16PaletteColors,	/* paletteColor */
    char16Pixels,		/* pixel (compressed) */
};
