/* $Id: types.h,v 1.2 1997/01/11 03:12:57 masa-k Exp $
 *
 *  Emi Clock $B!=(B $BFC<l$J7?$NDj5A(B
 */

/*
 *  Copyright (c) 1994, 1995, 1997 Masayuki Koba.
 *
 *  $BK\%=%U%H%&%'%"$N%=!<%9$d%P%$%J%j$r:FG[I[$9$k>l9g$O!"<!$N>r7o$r=e<i$7$F(B
 *  $B2<$5$$!#(B
 *
 *  1. $BK\%=%U%H%&%'%"$rF~<j$7$?J}$K$O!"(BX11$BHG(B Emi Clock $B$N;HMQ8"$H!"Bh;0<T(B
 *     $B$X$N:FG[I[8"$,G'$a$i$l$^$9!#$?$@$7!":FG[I[$K4X$7$F$O!"F~<j;~$N%*%j(B
 *     $B%8%J%k$N$^$^2~JQ$;$:$K9T$&$3$H$,>r7o$G$9!#(B
 *  2. $BK\%=%U%H%&%'%"$N0lIt$^$?$OA4It$rCx:n8"<T$KL5CG$G2~JQ$7$FG[I[$9$k$3(B
 *     $B$H$O$G$-$^$;$s!#(B
 *  3. $BK\%=%U%H%&%'%"$N0lIt$^$?$OA4It$rCx:n8"<T$KL5CG$GFs<!MxMQ$9$k$3$H$O(B
 *     $B$G$-$^$;$s!#(B
 *  4. $BK\%=%U%H%&%'%"$r%7%9%F%`$K%P%s%I%k$7$?$j!"%7%9%F%`$NDI2C%Q%C%1!<%8(B
 *     $B$H$7$FBh;0<T$K:FG[I[$7$?$j$9$k>l9g$O!";vA0$KCx:n8"<T$K5v2D$,I,MW$G(B
 *     $B$9!#(B
 *  5. $BK\%=%U%H%&%'%"$r>&MQ$K;HMQ$9$k>l9g(B($B6bA,E*Mx1W$rF@$k>l9g(B)$B$O!";vA0$K(B
 *     $BCx:n8"<T$K5v2D$,I,MW$G$9!#$3$N>l9g!"4pK\E*$KM-=~$H$J$j$^$9!#(B
 *  6. $BK\%=%U%H%&%'%"$rMxMQ$9$k$3$H$K$h$C$FH/@8$7$?$$$+$J$kB;32$b!"Cx:n8"(B
 *     $B<T$OIi$o$J$$$b$N$H$7$^$9!#$3$l$K9g0U$G$-$J$$>l9g$O!";HMQ8"$,$J$$$b(B
 *     $B$N$H$7$^$9!#(B
 *  7. $B!H(BEmi Clock$B!I$N>&I8$*$h$SK\%=%U%H%&%'%"$N2hA|$d%G%6%$%s$K4X$9$kCx:n(B
 *     $B8"$O!"(BMotosoft $B$3$H!HK\(B $B=SLi!I;a$,M-$7$^$9!#(B
 *  8. $B!H(BEmi Clock$B!I$N>&I8$*$h$S2hA|$d%G%6%$%s$O!"(BX11$BHG(B Emi Clock $B3+H/$N$?(B
 *     $B$a!"(BMotosoft $B$h$j!H8E>l(B $B@59T!I$X8D?ME*$K%i%$%;%s%96!M?$5$l$F$^$9!#(B
 *     $BBh;0<T$XFs<!%i%$%;%s%96!M?$9$k$3$H$OG'$a$i$l$F$*$j$^$;$s!#(B
 *  9. Motosoft $B$H8E>l$KL5CG$G!"K\%=%U%H%&%'%"$N2hA|%G!<%?$rFs<!MxMQ$9$k$3(B
 *     $B$H$r6X;_$7$^$9!#(B
 * 10. $B$3$3$K5-=R$7$?0J30$N8"Mx$K$D$$$F$O!"F|K\9q$NCx:n8"K!$K$h$k$b$N$H$7(B
 *     $B$^$9!#(B
 */

#ifndef	_EMI_TYPES_H_
#define	_EMI_TYPES_H_


/*
 *  $B%T%/%;%k05=L%$%a!<%8(B
 */
typedef struct {
    unsigned int	width, height;
    int			numOfPalettes;		/* $B%Q%l%C%H?t(B */
    unsigned char	*paletteColor;		/* RGBRGB... */
    unsigned char	*pixel;			/* $B05=L$5$l$?%T%/%;%kCM(B */
} PixelImage;


/*
 *  $B%S%C%H%^%C%W$N%F!<%V%k(B
 */
typedef struct {
    unsigned int	width, height;
    char		*bits;
} BitmapTable;


/*
 *  $B%+%i!<%^%C%W$+$i(B Alloc $B$7$?%+%i!<%;%k$N%T%/%;%kCM(B
 */
typedef struct {
    unsigned long	pixel;
    Boolean		isAlloc;
} AllocPixel;


/*
 *  $B%"%W%j%1!<%7%g%s%G!<%?9=B$BN(B
 */
typedef struct {
    Boolean	isNoSave;		/* $HOME/.emiclockrc $B$rJ]B8$7$J$$(B */
    Boolean	isNoStartupSound;	/* $B5/F02;!V$_$e$C!*!W$,$J$$!)(B */
    Boolean	isNoSoundCache;		/* $B%5%&%s%I$r%-%c%C%7%e2=$7$J$$!)(B */
    Boolean	isNoShape;		/* Shape Extension $B$,$J$$!)(B */
    Boolean	isPerfect;		/* $B5/F0;~$K%+%i!<%;%k$rA4$F3NJ]!)(B */
    Boolean	isGrayscale;		/* $B%0%l%$%9%1!<%kI=<(!)(B */
    Boolean	isGray4;		/* 4$B?'%0%l%$%9%1!<%kI=<(!)(B */
    Boolean	isMono;			/* $B%b%N%/%mI=<(!)(B */
} AppData, *AppDataPtr;


/*
 *  $B%"%i!<%`;~9o9=B$BN(B
 */
typedef struct {
    int		year;			/* $BG/(B($B@>Nq(B) - 1900 */
    int		month;			/* $B7n(B (1$B!A(B12) */
    int		date;			/* $BF|(B (1$B!A(B31) */
    int		hour;			/* $B;~(B (0$B!A(B23) */
    int		minute;			/* $BJ,(B (0$B!A(B59) */
    int		second;			/* $BIC(B (0$B!A(B59) */
} AlarmTime;


/*
 *  $HOME/.emiclockrc $BJ]B8%G!<%?(B
 */
typedef struct {
    Boolean	isNoSecond;		/* $BIC?KI=<($J$7(B */
    Boolean	isNoStartupSound;	/* $B5/F02;!V$_$e$C!*!W$,$J$$!)(B */
    Boolean	isHourlyCharChange;	/* $B#1;~4V$*$-$KJQ99(B */
    int		charNo;			/* $B%-%c%i%/%?$NHV9f(B */
    int		cbaseNo;		/* $BJ8;zHW$NHV9f(B */
    Boolean	isHourlyChime;		/* 0$BJ,%A%c%$%`$rLD$i$9(B */
    Boolean	isHalfHourChime;	/* 30$BJ,%A%c%$%`$rLD$i$9(B */
    Boolean	isPlayAlarm;		/* $B%"%i!<%`$rLD$i$9(B */
    AlarmTime	alarmTime;		/* $B%"%i!<%`;~9o(B */
    Boolean	isOneTime;		/* $B#12s$@$1DLCN$9$k!)(B */
    Boolean	isDailyAlarm;		/* $BKhF|DLCN$9$k!)(B */
} RcData;

#endif	/* !_EMI_TYPES_H_ */
